/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_MEDICO                                                   */
/* Tabela : MEDICO                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MEDICO'  and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_MEDICO
  GO


CREATE TRIGGER DTULTATU_MEDICO
ON MEDICO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'MEDICO', CDFILIAL, 'CDFILIAL=' + CDFILIAL + '; CDMEDICO=' + CDMEDICO + ';', GETDATE()
                               FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MEDICO
      SET DTULTATUMEDI = GETDATE()
      FROM INSERTED
      WHERE
         (MEDICO.CDMEDICO = INSERTED.CDMEDICO) 
   END;
END;
GO



