const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../../../json/leitorJson.po');
const titulosAPagarPagosPage = require('../../../../../page-objects/financeiro/titulosAPagar/operacoes/titulosAPagarPagos.po');


describe('Títulos a Pagar/Pagos', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        titulosAPagarPagosPage.abrir();
    });


    afterAll(() => {
        geral.sair();
    });


    it('Tela de Títulos a Pagar/Pagos', () => {
        expect(z.component.header.getTitle(element(by.id('Títulos a Pagar/Pagos'))));
    });


    it('Adicionar', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-10511995312368698244628')));
        geral.clickAcoes();
        geral.clickActionPorIndice(1);


        titulosAPagarPagosPage.adicionar(
            j.getValor('unidadeDeOrigem'),
            j.getValor('tipo'),
            j.getValor('fornecedor'),
            j.getValor('operacao'),
            j.getValor('serie'),
            j.getValor('valorDocumento'),
            j.getValor('tipoDeConta'));
        geral.clickFinalizar();
        geral.clickOk();


        geral.filterIt(j.getValor('fornecedor'));
        geral.clickGrid('NMRAZSOCFORN', j.getValor('fornecedor'), '10511995312368698244628');
        geral.trocarAba('Ajuste');
        geral.clickAdicionar();


        titulosAPagarPagosPage.editar(
            j.getValor('ajuste'),
            j.getValor('valor'));
        geral.clickSalvar();
        geral.clickOk();
        geral.clickVoltar();


        z.widget.grid.checkRow('10511995312368698244628', '0', 'true');
        geral.clickAcoes();
        geral.clickActionPorIndice(2);


        titulosAPagarPagosPage.incluir(
            j.getValor('vencimento'),
            j.getValor('motivo'));
        geral.clickConfirmar();
        geral.clickOk();


        browser.executeScript('$(\'div.zh-floating-control li.float-action .zh-icon-filter\').click()');
        z.field.calendar.selectDateCalendarField('DTVENBOLPAG', '20/12/2020', 'pt_br');
        z.component.footer.clickRightActionByLabel('OK', true);
        z.component.footer.clickRightActionByLabel('Aplicar filtro', true);
        geral.filterIt(j.getValor('fornecedor'));
        geral.clickGrid('NMRAZSOCFORN', j.getValor('fornecedor'), '10511995312368698244628');
        geral.clickVoltar();


        expect(geral.gridHasText('10511995312368698244628', j.getValor('fornecedor'), 3)).
            toEqual('CONOSCO COMERCIAL LTDA - EPP');
        expect(geral.gridHasText('10511995312368698244628', j.getValor('parcela'), 4)).
            toEqual('00');


        geral.clickGrid('NMRAZSOCFORN', j.getValor('fornecedor'), '10511995312368698244628');
        const el = element.all(by.css('#span-field-DSBOLETPAG > p'));


        el.getText().then(function (tipoDeConta) {
            expect(tipoDeConta).toEqual(['MANUTENCAO']);
        });
    });
});
